<ui:composition template="/WEB-INF/templates/layout.xhtml"
	xmlns="http://www.w3.org/1999/xhtml"
	xmlns:f="http://xmlns.jcp.org/jsf/core"
	xmlns:h="http://xmlns.jcp.org/jsf/html"
	xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
	xmlns:p="http://primefaces.org/ui">
	
	<ui:param name="title" value="Create Project" />
	
	<ui:define name="content">
		<div class="content-wrapper">
			<div class="content-header">
				<h1>Create project</h1>
				<h5>You can create a new project here.</h5>
			</div>
			<p:separator />
			<div class="content-body p-grid p-formgrid ui-fluid">
				<div class="card">
					<h:form id="newProjectForm">
						<p:messages id="messages" globalOnly="true" showDetail="true">
							<p:autoUpdate />
						</p:messages>
						<div class="form-element p-field">
							<p:outputLabel for="projectName" value="Name" />
							<p:inputText id="projectName" value="#{projectBacking.name}"
								required="true" 
								requiredMessage="Project name cannot be empty">
								<p:clientValidator event="blur" />
							</p:inputText>
							<small><p:message id="projectName-error" for="projectName" display="text" /></small>
						</div>
						<div class="form-element p-field">
							<p:outputLabel for="projectDescription" value="Description (optional)"/>
							<p:inputTextarea id="projectDescription" value="#{projectBacking.description}" 
								required="false"
								rows="5" 
								cols="50"
								autoResize="true"
								maxlength="250"
								counter="remainingChars" />
							<small>Remaining characters: <p:message id="remainingChars" for="projectDescription" display="text" /></small>
						</div>
						<div class="form-element p-field">
							<p:outputLabel for="startDate" value="Planned start date" />
							<p:datePicker id="startDate" value="#{projectBacking.startDate}"
								required="true"
								requiredMessage="Start date cannot be empty"
								monthNavigator="true"
								yearNavigator="true"
								showOtherMonths="true"
								selectOtherMonths="true"
								placeholder="e.g. 10/30/2019"
								pattern="MM/dd/yyyy">
								<p:clientValidator />
								<f:convertDateTime pattern="MM/dd/yyyy" type="localDate" />
								<p:ajax event="dateSelect" listener="#{projectBacking.onStartDateSelect}" update="startDate-error" />
							</p:datePicker>
							<small><p:message id="startDate-error" for="startDate" display="text" /></small>
						</div>
						<div class="form-element p-field">
							<p:outputLabel for="dueDate" value="Planned due date" />
							<p:datePicker id="dueDate" value="#{projectBacking.dueDate}"
								required="true"
								requiredMessage="Due date cannot be empty"
								monthNavigator="true"
								yearNavigator="true"
								showOtherMonths="true"
								selectOtherMonths="false"
								placeholder="e.g. 10/30/2019"
								pattern="MM/dd/yyyy">
								<p:clientValidator />
								<f:convertDateTime pattern="MM/dd/yyyy" type="localDate" />
								<p:ajax event="dateSelect" listener="#{projectBacking.onDueDateSelect}" update="dueDate-error" />
							</p:datePicker>
							<small><p:message id="dueDate-error" for="dueDate" display="text" /></small>
						</div>
						<div class="form-element p-field">
							<p:outputLabel for="projectPriority" value="Priority" />
							<p:selectOneMenu id="projectPriority" value="#{projectBacking.priorityId}" effect="none">
								<f:selectItem itemLabel="Select a priority" itemValue="" noSelectionOption="true" />
								<f:selectItems value="#{projectBacking.priorities}" 
									var="priority" 
									itemLabel="#{priority.name}" 
									itemValue="#{priority.id}" />
							</p:selectOneMenu>
							<div class="btn-add">
								<p:commandButton id="btnNewPriority" value="New priority" oncomplete="PF('newPriorityDialog').show()" />
							</div>
						</div>
						<div class="btn-container">							
							<p:commandButton id="btnCreateProject" 
								action="#{projectBacking.createNewProject}" 
								value="Create" 
								validateClient="true" 
								update="@form" 
								styleClass="form-button" />
							<p:linkButton outcome="/user/dashboard" value="Cancel" styleClass="form-button btn-delete"/>
						</div>
					</h:form>
				</div>
				
				<p:dialog id="newPriorityDialog" widgetVar="newPriorityDialog" header="New project priority" modal="true">
					<h:form id="newPriority">
						<p:panelGrid columns="2">
							<p:outputLabel for="priorityName" value="New priority name: " />
							<p:inputText id="priorityName" value="#{projectBacking.newPriorityName}" />
						</p:panelGrid>
						<div class="btn-container">
							<div class="ui-g-6">
								<p:commandButton id="btnCreatePriority" value="Create" 
									action="#{projectBacking.createNewPriority()}" 
									oncomplete="PF('newPriorityDialog').hide()"
									update="newProjectForm:projectPriority" />
							</div>
							<div class="ui-g-6">
								<p:commandButton id="btnCancelCreatePriority" value="Cancel" onclick="PF('newPriorityDialog').hide()" />
							</div>
						</div>
					</h:form>
				</p:dialog>
				
			</div>
		</div>
	</ui:define>
</ui:composition>